{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O+,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

program parser;
uses ParsUnit,DynSys;
var
  str:string;
  fin,fout:text;
  i,j:integer;
  pds:PDynSystem;
  pget:^TGetInitValues;
  MustFinish:boolean;
begin
  repeat
    str:='';
    writeln(' 䠩 (  䠩)  㫠?');
    readln(str);
    if str='' then HALT(1);
    {$i-}
    assign(fin,str); reset(fin);
    {$i+}
  until IOResult=0;
  assign(fout,'parse.log');
  rewrite(fout);
  pds:=parse(fin,fout);
  if pds=nil then begin
    writeln('訡  室 䠩.');
    writeln(' ⮪  䠩 parse.log');
    Halt;
  end
  else begin
    append(fout);
    pds^.Print(fout);
    close(fout);
  end;
  writeln(' ',pds^.NVars,' ६:');
  for i:=1 to pds^.NVars do writeln(pds^.VarNames^[i]^);
  writeln(' ',pds^.NConst,'  ⠭:');
  for i:=1 to pds^.NConst do writeln(pds^.ConstNames^[i]^);
  repeat
    str:='';
    writeln(' 䠩 (  䠩)  砫묨 祭ﬨ?');
    readln(str);
    if str<>'' then begin
      {$i-}
      assign(fin,str); reset(fin);
      {$i+}
    end;
  until (str='') or (IOResult=0);
  if str<>'' then begin
    pds^.AllocMemForWork;
    new(pget,Init);
    pget^.SetDynSystem(pds);
    if not pget^.ReadValuesFromFile(fin) then
      writeln('訡  뢠 砫 祭');
    close(fin);
    if not pget^.AreAllDefined then
      writeln('   ६  ⠭  砫 祭:');
    for i:=1 to pds^.NVars do
      if not pget^.IsVDefined^[i] then
        writeln('६ ',pds^.VarNames^[i]^,'= ?')
      else
        writeln('६ ',pds^.VarNames^[i]^,'= ',pds^.v0^[i]:6:2);
    for i:=1 to pds^.NConst do
      if not pget^.IsCDefined^[i] then
        writeln('⠭ ',pds^.ConstNames^[i]^,'= ?')
      else
        writeln('⠭ ',pds^.ConstNames^[i]^,'= ',pds^.c0^[i]:6:2);
    repeat
      str:='';
      writeln(' 䠩 (  䠩)  ᫮ﬨ ⠭?');
      readln(str);
      if str<>'' then begin
        {$i-}
        assign(fin,str); reset(fin);
        {$i+}
      end;
    until (str='') or (IOResult=0);
    if str<>'' then begin
      pget^.ReadFinishConditionsFromFile(fin);
      close(fin);
      if pds^.IsTDefined then
        writeln('t>=',pds^.tfin);
      for i:=1 to pds^.ncond do
        with pds^.cond^[i]^ do begin
          write(pds^.VarNames^[VarN]^,':');
          if IsLowDefined then write('  ',LowBound:6:2);
          if IsHighDefined then write('  ',HighBound:6:2);
          writeln;
        end;
    end;
    dispose(pget,Done);
    {calculations}
    pds^.Reset;
    i:=1; MustFinish:=false;
    while not MustFinish and (i<=5) do begin
      pds^.NextStep;
      MustFinish:=pds^.MustFinish;
      writeln('蠣 ',pds^.tcurr,' ----------------');
      for j:=1 to pds^.NVars do begin
        write(pds^.VarNames^[j]^);
        if pds^.IsCurrUndefined^[j] then writeln('  ।')
        else writeln('=',pds^.vcurr^[j]:6:2);
      end;
      if MustFinish then writeln('⨣ ᫮ 砭 ');
      readln;
      inc(i);
    end;
  end;
  dispose(pds,Done);
end.
