{$A+,B-,D+,E+,F+,G-,I+,L+,N-,O+,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 1024,0,0}

unit TraxCol;

interface

uses WinTypes,WinProcs,Objects,OWindows,ODialogs,ToolHelp,Strings,
     TpString,
     TraxRun;

type PColorsDlg=^TColorsDlg;
     TColorsDlg=object(TDialog)
       pds:PDynSystem;
       constructor Init (AParent:PWindowsObject; ThePDS:PDynSystem);
       procedure SetupWindow; virtual;
       function CanClose : boolean; virtual;
     end;

implementation

constructor TColorsDlg.Init (AParent:PWindowsObject; ThePDS:PDynSystem);
begin
  inherited Init (AParent, 'ColorDlg');
  pds:=ThePDS;
end;

procedure TColorsDlg.SetupWindow;
var p:array[0..100] of char;
begin
  inherited SetupWindow;
  SetWindowText(GetDlgItem(HWindow,101),StrPCopy(p,long2str(pds^.NColors)));
  SetWindowText(GetDlgItem(HWindow,102),StrPCopy(p,long2str(pds^.ColorsChangeAfter)));
end;

function TColorsDlg.CanClose : boolean;
var p:array[0..100] of char;
    str:string;
    k,l:integer;
begin
  CanClose:=false;
  GetWindowText(GetDlgItem(HWindow,101),p,100);
  str:=trim(StrPas(p));
  if (str='') or not str2int(str,k) or (k<1) or (k>7) then begin
    MessageBox(HWindow,'Illegal number of colors: must be from 1 to 7',
      nil,MB_OK or MB_ICONEXCLAMATION);
    SetFocus(GetDlgItem(HWindow,101));
    EXIT;
  end;
  GetWindowText(GetDlgItem(HWindow,102),p,100);
  str:=trim(StrPas(p));
  if (str='') or not str2int(str,l) or (l<0) then begin
    MessageBox(HWindow,'Number of steps to change color should be non-negative integer number',
      nil,MB_OK or MB_ICONEXCLAMATION);
    SetFocus(GetDlgItem(HWindow,102));
    EXIT;
  end;
  pds^.NColors:=k; pds^.ColorsChangeAfter:=l;
  CanClose:=true;
end;


end.