{$A+,B-,D+,E+,F+,G-,I+,L+,N-,O+,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 1024,0,0}

unit Trax_Abo;

interface

uses WinTypes,WinProcs,Objects,OWindows,ODialogs,ToolHelp,Strings;

type PAboutDlg=^TAboutDlg;
     TAboutDlg=object(TDialog)
       Version:string;
       constructor Init (AParent:PWindowsObject; AVersion:string);
       procedure SetupWindow; virtual;
     end;

implementation

constructor TAboutDlg.Init (AParent:PWindowsObject; AVersion:string);
begin
  inherited Init(AParent,'AboutDlg');
  Version:=AVersion;
end;

procedure TAboutDlg.SetupWindow;
Var M: TMemManInfo;
    H: TSysHeapInfo;
    temp:array[0..127] of Char;
    PercentFree,UserFree: Word;
begin
  inherited SetupWindow;

  if (GetWinFlags and wf_Enhanced)<>0 then
    SendDlgItemMsg(101,wm_SetText,0,LongInt(PChar('386 Enhanced Mode')))
  else
    SendDlgItemMsg(101,wm_SetText,0,LongInt(PChar('Standard Mode')));
  Str(GetFreeSpace(0) div 1024,Temp); Strcat(Temp,' K');

  SendDlgItemMSg(104,wm_SetText,0,LongInt(@TEMP));
  H.dwSize:=SizeOf(TSysHeapInfo); SystemHeapInfo(@H);

  PercentFree:=H.wUserFreePercent;
  Str(PercentFree,Temp); StrCat(Temp,' %');
  SendDlgItemMsg(102,wm_SetText,0,LongInt(@TEMP));

  PercentFree := H.wGDIFreePercent;
  Str(PercentFree,Temp); StrCat(Temp,' %');
  SendDlgItemMsg(103,wm_SetText,0,LongInt(@TEMP));

  StrPCopy(temp,Version);
  SendDlgItemMsg(105,wm_SetText,0,LongInt(@TEMP));

end;

end.